/*
 * Copyright 2006 blackcore networking
 * source@source.blackcore.net
 *
 * compiled with mingw: gcc (GCC) 3.2.3 (mingw special 20030504-1)
 * gcc -o myprogram.exe myprogram.cpp -Xlinker -image-base=0x10000000
 *
 * should compile with anything else as long as you change the base starting
 * address to 10000000 and the remote program is not using 10000000 in memory
 *
 * can only run program once against the remote pid, unless you unallocate the memory
 * you previously allocated
 *
 * credit goes to Justin Lesarge (www.jl.mu) for the method i used for
 * process intercepting, along with writing the TakeOver() call
 * - slink
*/
#define WINVER 0x0500 // MB_SERVICE_NOTIFICATION requires this in the SDK
#define _WIN32_WINNT WINVER
#pragma comment(lib, "user32.lib")
#pragma comment(linker, "/BASE:0x10000000")
#include <stdio.h>
#include <windows.h>
#include <string.h>
#include <stdarg.h>

char *GetError();

/*int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, 
int nCmdShow) { */
int mprintf(char *fmt, ...) {
	int n;
	char buf[512];
	va_list vargs;
	va_start(vargs, fmt);
	memset(buf,0,sizeof(buf));
	n=_vsnprintf(buf, 512, fmt, vargs);
	MessageBox(NULL, buf, "mprintf", MB_OK|MB_SERVICE_NOTIFICATION);
	va_end(vargs);
	return n;
}
int log(char *fmt, ...) {
	int n;
	char buf[512];
	va_list vargs;
	va_start(vargs, fmt);
	memset(buf,0,sizeof(buf));
	n=_vsnprintf(buf, 512, fmt, vargs);
	FILE *fd = fopen("c:\\log.txt","a");
	fprintf(fd, "%s", buf);
	fclose(fd);
//	MessageBox(NULL, buf, "mprintf", MB_OK|MB_SERVICE_NOTIFICATION);
	va_end(vargs);
	return n;
}

unsigned char m_SendMessage[7], *p_SendMessage, temp[7], m_GetMessage[7], *p_GetMessage;
void TakeOver(unsigned char *Current, void *New) {
	DWORD Old;
	if (VirtualProtect(Current, 16, PAGE_EXECUTE_READWRITE, &Old) == FALSE) {
		MessageBox(NULL,"error",0,0);
		return;
	}
	Current[0] = 0xb8;
	*((long*)(Current+1))=(long)(New);
	Current[5] = 0xff;
	Current[6] = 0xe0;
}
BOOL WINAPI myGetMessage(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax) {
	BOOL retval;
	memcpy(temp, p_GetMessage, 7);
	memcpy(p_GetMessage, m_GetMessage, 7);
	if (lpMsg->message == WM_KEYDOWN) {
		lpMsg->wParam = 65;
	}
	retval = GetMessage(lpMsg, hWnd, wMsgFilterMin, wMsgFilterMax);
	memcpy(p_GetMessage, temp, 7);
	return retval;
}
LRESULT WINAPI mySendMessage(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
	LRESULT tempret;
	memcpy(temp, p_SendMessage, 7);
	memcpy(p_SendMessage, m_SendMessage, 7);
	tempret = SendMessage(hWnd, Msg, wParam, lParam);
	memcpy(p_SendMessage, temp, 7);
	return tempret;
}

DWORD WINAPI ThreadProc(DWORD args) {
	HMODULE hDll = GetModuleHandle("user32");
	if (hDll == NULL) {
		mprintf("GetModuleHandle: %s\n", GetError());
	}


	if (args == 2) {
/*		p_DispatchMessage = (unsigned char *)GetProcAddress(hDll, "DispatchMessageW");
		memcpy(m_DispatchMessage, p_DispatchMessage, 7);
		TakeOver(p_DispatchMessage, (void*)myDispatchMessage); */

/*		p_GetMessage = (unsigned char *)GetProcAddress(hDll, "GetMessageW");
		memcpy(m_GetMessage, p_GetMessage, 7);
		TakeOver(p_GetMessage, (void*)myGetMessage); */

/*		p_SendMessage = (unsigned char *)GetProcAddress(hDll, "SendMessageW");
		memcpy(m_SendMessage, p_SendMessage, 7);
		TakeOver(p_SendMessage, (void*)mySendMessage); */
	}
	if (args == 1) {
		mprintf("Code is now loaded into the pid.");
	} else if (args == 0) {
		ExitProcess(0);
	}
	return 0;
}
int main(int argc, char *argv[]) {
	int pid, type;
	DWORD Old;
	HANDLE hProcess;
	HANDLE pstart;
	MEMORY_BASIC_INFORMATION mb;
	DWORD dOut;
	HANDLE hThread;
	DWORD dThreadID;
	void *ptr;
	SIZE_T mySize;
	long start, rstart, realsize = 0;

	if (argc < 3) {
		printf("usage: %s <pid> <type>\n", argv[0]);
		printf(" 0 = closes remote thread with ExitProcess(0)\n");
		printf(" 1 = calls MessageBox from remote thread\n");
		printf(" 2 = kill keyboard input on process\n");
		return 1;
	}
	pid = atoi(argv[1]);
	type = atoi(argv[2]);
	hProcess = OpenProcess(PROCESS_ALL_ACCESS, TRUE, pid);
	if (hProcess == NULL) {
		printf("Cannot open process! %s\n", GetError());
		return 1;
	}
	pstart = GetModuleHandle(NULL);
	memcpy(&start, (long *)&pstart, sizeof(start));
	printf("start point: %p\n", start);
	for(;;) {
		mySize = VirtualQuery((const void *)start, &mb, sizeof(mb));
		if (mySize == 0) {
			printf("mysize is 0, breaking\n");
			break;
		}
		if (mb.State & MEM_FREE) {
			break;
		}
		printf("size is %d (%d) (%p)\n", mySize, mb.RegionSize, mb.BaseAddress);
		start+=mb.RegionSize;
		realsize+=mb.RegionSize;
	}
	printf("total size: %d\n", realsize);
		ptr = VirtualAllocEx(hProcess, (void *)GetModuleHandle(NULL), realsize, MEM_COMMIT|MEM_RESERVE, PAGE_EXECUTE_READWRITE);
		if (ptr == NULL) {
			printf("VirtualAllocEx (%p): %s\n", start, GetError());
			return 1;
		}
		printf("success! allocated at %p\n", ptr);
		if (WriteProcessMemory(hProcess, ptr, GetModuleHandle(NULL), realsize, &dOut) == FALSE) {
			printf("WriteProcessMemory failed: %s\n", GetError());
			return 1;
		}
		printf("WriteProcessMemory wrote: %d bytes\n", dOut);
	if ((hThread = CreateRemoteThread(hProcess, NULL,0, (LPTHREAD_START_ROUTINE)ThreadProc, (DWORD *)type, 0, &dThreadID)) == NULL) {
		printf("CreateRemoteThread: %s\n", GetError());
		return 1;
	}

	return 0;
}

char *GetError() {
    LPVOID lpMsgBuf;
    DWORD dw = GetLastError(); 

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );
    /*wsprintf(szBuf, 
        "%s failed with error %d: %s", 
        lpszFunction, dw, lpMsgBuf);  */
 
    return (char *)lpMsgBuf;

    //LocalFree(lpMsgBuf);
}

